#include <stdio.h>
#include "common.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
 if (argc != 3)
 {
  fprintf(stderr,"Usage: %s <rows> <cols>\n",argv[0]);
  exit(1);
 }

 new2dsc(atoi(argv[1]),atoi(argv[2]));

 exit(0);
}

int	new2dsc(r,c)
int	r, c;
{
 int	size;

 n2t(r,c,IN_TERR_FILE);
 n2o(r,c,IN_OBJE_FILE);
 n2v(r,c,IN_UNIT_FILE);

 fprintf(stdout,".hex file[s] listed\n");

 return (0);
}

int	n2t(y,x,name)
int	x, y;
char	*name;
{
 FILE	*tmp, *fopen();
 byte	b0, b1;
 int	cd, lx, ly, offset, d;

 tmp = fopen(name,"w");
 /* output file */

 if (tmp == NULL)
 {
  fprintf(stderr,"n2t(): unable to open %s as output.\n",name);
  exit(1);
 }

 fprintf(tmp,"Terrain Map of ---\n");
 fprintf(tmp,"rows %d cols %d\n",y,x);
 fprintf(tmp,"   ");
 for (lx=0; lx<x; lx += 1)
  fprintf(tmp,"%2d ",lx);
 fprintf(tmp,"\n");

 for (ly=0; ly<y; ly++)
 {
  fprintf(tmp,"%2d ",ly);

  for (lx=0; lx<x; lx += 2)
   fprintf(tmp,"   >-<");
  /* 1st pass [odd] */

  fprintf(tmp," %2d\n",ly);
  fprintf(tmp,"   ");

  for (lx=1; lx<x; lx += 2)
   fprintf(tmp,">-<   ");
  /* 2nd pass [even] */

  fprintf(tmp,"\n");
 }
 fprintf(tmp,"   ");
 for (lx=0; lx<x; lx += 1)
  fprintf(tmp,"%2d ",lx);
 fprintf(tmp,"\n");
 fclose(tmp);

 return(0);
}

int	n2o(y,x,name)
int	x, y;
char	*name;
{
 FILE	*tmp, *fopen();
 byte	b0, b1;
 int	cd, lx, ly, offset, d;

 tmp = fopen(name,"w");
 /* output file */

 if (tmp == NULL)
 {
  fprintf(stderr,"n2o(): unable to open %s as output.\n",name);
  exit(1);
 }

 fprintf(tmp,"Object Map of ---\n");
 fprintf(tmp,"rows %d cols %d\n",y,x);
 fprintf(tmp,"   ");
 for (lx=0; lx<x; lx += 1)
  fprintf(tmp,"%2d ",lx);
 fprintf(tmp,"\n");

 for (ly=0; ly<y; ly++)
 {
  fprintf(tmp,"%2d ",ly);

  for (lx=0; lx<x; lx += 2)
   fprintf(tmp,"   >-<");
  /* 1st pass [odd] */

  fprintf(tmp," %2d\n",ly);
  fprintf(tmp,"   ");

  for (lx=1; lx<x; lx += 2)
   fprintf(tmp,">-<   ");
  /* 2nd pass [even] */

  fprintf(tmp,"\n");
 }
 fprintf(tmp,"   ");
 for (lx=0; lx<x; lx += 1)
  fprintf(tmp,"%2d ",lx);
 fprintf(tmp,"\n");
 fclose(tmp);

 return(0);
}

int	n2v(y,x,name)
int	x, y;
char	*name;
{
 FILE	*tmp, *fopen();
 byte	b0, b1;
 int	cd, lx, ly, offset, d;

 tmp = fopen(name,"w");
 /* output file */

 if (tmp == NULL)
 {
  fprintf(stderr,"n2v(): unable to open %s as output.\n",name);
  exit(1);
 }

 fprintf(tmp,"Vehicle Map of ---\n");
 fprintf(tmp,"rows %d cols %d\n",y,x);
 fprintf(tmp,"   ");
 for (lx=0; lx<x; lx += 1)
  fprintf(tmp,"%2d ",lx);
 fprintf(tmp,"\n");

 for (ly=0; ly<y; ly++)
 {
  fprintf(tmp,"%2d ",ly);

  for (lx=0; lx<x; lx += 2)
   fprintf(tmp,"   >-<");
  /* 1st pass [odd] */

  fprintf(tmp," %2d\n",ly);
  fprintf(tmp,"   ");

  for (lx=1; lx<x; lx += 2)
   fprintf(tmp,">-<   ");
  /* 2nd pass [even] */

  fprintf(tmp,"\n");
 }
 fprintf(tmp,"   ");
 for (lx=0; lx<x; lx += 1)
  fprintf(tmp,"%2d ",lx);
 fprintf(tmp,"\n");
 fclose(tmp);

 return(0);
}
